org.apache.solr.handler.admin

## Class CoreAdminHandler

- java.lang.Object
- - org.apache.solr.handler.RequestHandlerBase
  - - org.apache.solr.handler.admin.CoreAdminHandler

- All Implemented Interfaces:
    SolrInfoMBean, NestedRequestHandler, SolrRequestHandler, PermissionNameProvider

      public class CoreAdminHandler
      extends RequestHandlerBase
      implements PermissionNameProvider

  Since:
    solr 1.3

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static interface` | `CoreAdminHandler.Invocable` used by the INVOKE action of core admin handler

    - ### Nested classes/interfaces inherited from interface org.apache.solr.security.PermissionNameProvider

      `PermissionNameProvider.Name`

    - ### Nested classes/interfaces inherited from interface org.apache.solr.core.SolrInfoMBean

      `SolrInfoMBean.Category`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `COMPLETED`
    `protected CoreContainer` | `coreContainer`
    `static String` | `FAILED`
    `protected static int` | `MAX_TRACKED_REQUESTS`
    `protected ExecutorService` | `parallelExecutor`
    `static com.google.common.collect.ImmutableMap<String,String>` | `paramToProp`
    `protected Map<String,Map<String,org.apache.solr.handler.admin.CoreAdminHandler.TaskObject>>` | `requestStatusMap`
    `static String` | `RESPONSE`
    `static String` | `RESPONSE_MESSAGE`
    `static String` | `RESPONSE_STATUS`
    `static String` | `RUNNING`

    - ### Fields inherited from class org.apache.solr.handler.RequestHandlerBase

      `appends, defaults, httpCaching, initArgs, invariants`

    - ### Fields inherited from interface org.apache.solr.security.PermissionNameProvider

      `ANY, NULL, values`

    - ### Fields inherited from interface org.apache.solr.request.SolrRequestHandler

      `TYPE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CoreAdminHandler()`
    `CoreAdminHandler(CoreContainer coreContainer)` Overloaded ctor to inject CoreContainer into the handler.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected static Map<String,String>` | `buildCoreParams(SolrParams params)`
    `CoreContainer` | `getCoreContainer()` The instance of CoreContainer this handler handles.
    `String` | `getDescription()` Simple one or two line description
    `PermissionNameProvider.Name` | `getPermissionName(AuthorizationContext ctx)`
    `protected void` | `handleCustomAction(SolrQueryRequest req, SolrQueryResponse rsp)` Handle Custom Action.
    `void` | `handleRequestBody(SolrQueryRequest req, SolrQueryResponse rsp)`
    `void` | `init(NamedList args)` Initializes the `SolrRequestHandler` by creating three `SolrParams` named.
    `protected static String` | `normalizePath(String path)`
    `static ModifiableSolrParams` | `params(String... params)`
    `void` | `shutdown()` Method to ensure shutting down of the ThreadPool Executor.

    - ### Methods inherited from class org.apache.solr.handler.RequestHandlerBase

      `getCategory, getDocs, getInitArgs, getName, getPluginInfo, getRequestHandler, getSolrParamsFromNamedList, getSource, getStatistics, getSubHandler, getVersion, handleRequest, setPluginInfo`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### coreContainer

          protected final CoreContainer coreContainer

    - #### requestStatusMap

          protected final Map<String,Map<String,org.apache.solr.handler.admin.CoreAdminHandler.TaskObject>> requestStatusMap

    - #### parallelExecutor

          protected final ExecutorService parallelExecutor

    - #### MAX_TRACKED_REQUESTS

          protected static int MAX_TRACKED_REQUESTS

    - #### RUNNING

          public static String RUNNING

    - #### COMPLETED

          public static String COMPLETED

    - #### FAILED

          public static String FAILED

    - #### RESPONSE

          public static String RESPONSE

    - #### RESPONSE_STATUS

          public static String RESPONSE_STATUS

    - #### RESPONSE_MESSAGE

          public static String RESPONSE_MESSAGE

    - #### paramToProp

          public static com.google.common.collect.ImmutableMap<String,String> paramToProp

  - ### Constructor Detail

    - #### CoreAdminHandler

          public CoreAdminHandler()

    - #### CoreAdminHandler

          public CoreAdminHandler(CoreContainer coreContainer)

      Overloaded ctor to inject CoreContainer into the handler.
      Parameters:
        `coreContainer` - Core Container of the solr webapp installed.

  - ### Method Detail

    - #### init

          public final void init(NamedList args)

      Description copied from class: `RequestHandlerBase`
      Initializes the `SolrRequestHandler` by creating three `SolrParams` named.

      Name | Description
      --- | ---
      defaults | Contains all of the named arguments contained within the list element named "defaults".
      appends | Contains all of the named arguments contained within the list element named "appends".
      invariants | Contains all of the named arguments contained within the list element named "invariants".

      Example:

           <lst name="defaults">
           <str name="echoParams">explicit</str>
           <str name="qf">text^0.5 features^1.0 name^1.2 sku^1.5 id^10.0</str>
           <str name="mm">2<-1 5<-2 6<90%</str>
           <str name="bq">incubationdate_dt:[* TO NOW/DAY-1MONTH]^2.2</str>
           </lst>
           <lst name="appends">
           <str name="fq">inStock:true</str>
           </lst>

           <lst name="invariants">
           <str name="facet.field">cat</str>
           <str name="facet.field">manu_exact</str>
           <str name="facet.query">price:[* TO 500]</str>
           <str name="facet.query">price:[500 TO *]</str>
           </lst>

      Specified by:
        `init` in interface `SolrRequestHandler`
      Overrides:
        `init` in class `RequestHandlerBase`
      Parameters:
        `args` - The `NamedList` to initialize from
      See Also:
        `RequestHandlerBase.handleRequest(org.apache.solr.request.SolrQueryRequest, org.apache.solr.response.SolrQueryResponse)`, `RequestHandlerBase.handleRequestBody(org.apache.solr.request.SolrQueryRequest, org.apache.solr.response.SolrQueryResponse)`, `SolrPluginUtils.setDefaults(org.apache.solr.request.SolrQueryRequest, org.apache.solr.common.params.SolrParams, org.apache.solr.common.params.SolrParams, org.apache.solr.common.params.SolrParams)`, `See also the example solrconfig.xml located in the Solr codebase (example/solr/conf).`

    - #### getCoreContainer

          public CoreContainer getCoreContainer()

      The instance of CoreContainer this handler handles. This should be the CoreContainer instance that created this handler.
      Returns:
        a CoreContainer instance

    - #### handleRequestBody

          public void handleRequestBody(SolrQueryRequest req,
                                        SolrQueryResponse rsp)
                                 throws Exception

      Specified by:
        `handleRequestBody` in class `RequestHandlerBase`
      Throws:
        `Exception`

    - #### handleCustomAction

          protected void handleCustomAction(SolrQueryRequest req,
                                            SolrQueryResponse rsp)

      Handle Custom Action.

      This method could be overridden by derived classes to handle custom actions.
      By default - this method throws a solr exception. Derived classes are free to write their derivation if necessary.

    - #### buildCoreParams

          protected static Map<String,String> buildCoreParams(SolrParams params)

    - #### normalizePath

          protected static String normalizePath(String path)

    - #### params

          public static ModifiableSolrParams params(String... params)

    - #### getDescription

          public String getDescription()

      Description copied from interface: `SolrInfoMBean`
      Simple one or two line description
      Specified by:
        `getDescription` in interface `SolrInfoMBean`
      Specified by:
        `getDescription` in class `RequestHandlerBase`

    - #### getPermissionName

          public PermissionNameProvider.Name getPermissionName(AuthorizationContext ctx)

      Specified by:
        `getPermissionName` in interface `PermissionNameProvider`

    - #### shutdown

          public void shutdown()

      Method to ensure shutting down of the ThreadPool Executor.

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.